﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Diagrams.Core;

namespace ClassDiagram
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            DiagramConstants.ContainerMargin = 0;
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.book.AddProperty();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.book.AddField();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            this.book.AddRelationship();
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            var newClass = new ClassShape() { Content = "New Class", Position = new Point(300, 120) };
            newClass.Loaded += this.OnNewClassLoaded;
            this.diagram.Items.Add(newClass);
        }

        void OnNewClassLoaded(object sender, RoutedEventArgs e)
        {
            var newClass = sender as ClassShape;
            if (newClass != null)
            {
                newClass.Loaded -= this.OnNewClassLoaded;
                this.Dispatcher.BeginInvoke(new Action(() =>
                    {
                        newClass.AddField();
                        newClass.AddProperty();
                    }));
            }
        }

        private void OnConnectionManipulationCompleted(object sender, Telerik.Windows.Controls.Diagrams.ManipulationRoutedEventArgs e)
        {
            if (e.ManipulationStatus == ManipulationStatus.Attaching)
            {
                var source = e.Connection.Source;
                var target = e.Shape;
                // Move source and target to Relationships
            }
        }
    }
}
